#Written by Emma Tait for FEMC NY Rec Data project
#This script gets the centroid of the eddMap polygons and merges them with points
#outputs result to NY_RecData.gdb
#Last Updated 21 October 2019
#*************IMPORTANT NOTE****************
#Before this script is run. The polygons that cross town boundaries must be split using ArcPro
#pull in tblOrigins and polygon_allStates.
#start an edit session on polygon_allStates.
#select by location from tblOrigins where features are crossed by polygon_allStates
#use the split features tool in the editing toolbar with the target as polygon_allStates
import arcpy
import os

path = r'I:\WorkingProjects\NY_RecData\InvasivePlantData\scratch.gdb'
polygon = 'polygons_allStates'
points = 'points_allStates'
arcpy.env.workspace = path
arcpy.env.overwriteOutput = True;

polyToPt = arcpy.FeatureToPoint_management(polygon,'polyToPt')

eddMap = arcpy.Merge_management([points,polyToPt],'EDDmap_9states')
spatialRef = arcpy.SpatialReference('NAD 1983')
eddMap = arcpy.Project_management(eddMap,'EDDmap_9states_reproj',spatialRef)
arcpy.CopyFeatures_management(eddMap, r'I:\WorkingProjects\NY_RecData\SpatialData\NY_RecData.gdb\EDDmap_9states')

print ('script complete')
