#Written by Emma Tait for FEMC NY Rec Data project
#This script matches trail register trip data to Adirondack trailhead locations
#Last Updated  14 November 2019

## ****** IMPORTANT NOTES ********
# MatchOrigins.py needs to be run first!
# This requres a CSV table of the attributes from the ADK trailhead point shapefile.

import csv

# file of ADK trailheads
destfile = r'I:\WorkingProjects\NY_RecData\SpatialData\destinationTables\tblDestinations.csv'

# this is the file produced by MatchOrigins.py. It is also the file output for this script
trips = r'I:\WorkingProjects\NY_RecData\tblTrips.csv'
##tripstemp=r'I:\WorkingProjects\NY_RecData\tblTrips_origins_matched_temp.csv'
unmatchedTripsDest = r'I:\WorkingProjects\NY_RecData\unmatchedTripsDestinations.csv'
# variables 
noMatchList = set(())
matchList = set(())
noMatchDest = []
matchDest = []

#get all of the trips from matched origins
with open (trip) as tripcsv:
    trip = csv.reader(tripcsv, delimiter=',')   
    for tr in trip:
        trailhead = tr[4] #matched names
        matched = 0
        tempMatches = []
        #get all of the trailheads
        with open (destfile) as destcsv:
            dest = csv.reader(destcsv, delimiter=',')
            temp ={}
            for d in dest:
                name = d[8]
                destID = d[7]
                received = d[3]
                #match trailheads with trips
                if name.startswith(trailhead.upper(),0,len(trailhead))and received.lower() == 'yes' : #
                    temp ={'pkTripID': tr[0],'fkOriginGroupID': tr[1],'fkOriginID':tr[2],'fkDestinationID':destID,'trailRegister':name,'trailName':tr[3], 'matchedTrailname':tr[4],'mgmtUnit': tr[5],'date': tr[6], 'state':tr[7],'county': tr[12], 'town':tr[8],'originalTown':tr[9],'NYmatchedTown':tr[10],'politicalEntity':tr[11],'group_size':tr[13],'stay_length':tr[14],'user_days':tr[15],'destination':tr[16]} 
                    matched += 1
                    tempMatches.append(temp)
                    matchList.add('trailhead:'+trailhead+', match count: '+str(matched) not in matchList)
                    
            #if there are no matches or there are multiple matches then the trip destination needs to be checked
            if matched ==0:
                matched2 = 0
                temp2 = {}
                #check if the trail name is in the register name but not necessarily at the beginning
                with open (destfile) as destcsv:
                    dest = csv.reader(destcsv, delimiter=',')
                    for d in dest:
                        name = d[8]
                        destID = d[7]
                        received = d[3]
                        if trailhead.upper() in name:
                            temp2 ={'pkTripID': tr[0],'fkOriginGroupID': tr[1],'fkOriginID':tr[2],'fkDestinationID':destID,'trailRegister':name,'trailName':tr[3], 'matchedTrailname':tr[4],'mgmtUnit': tr[5],'date': tr[6], 'state':tr[7],'county': tr[12], 'town':tr[8],'originalTown':tr[9],'NYmatchedTown':tr[10],'politicalEntity':tr[11],'group_size':tr[13],'stay_length':tr[14],'user_days':tr[15],'destination':tr[16]}
                            matched2 += 1     
                    if matched2 == 1:
                        matchDest.append(temp)                        
                    else:
                        if 'trailhead:'+trailhead+', match count: '+str(matched2) not in matchList:
                            noMatchList.add('trailhead:'+trailhead+', match count: '+str(matched2))
                        temp2 ={'pkTripID': tr[0],'fkOriginGroupID': tr[1],'fkOriginID':tr[2],'trailName':tr[3], 'matchedTrailname':tr[4],'mgmtUnit': tr[5],'date': tr[6], 'state':tr[7],'county': tr[12], 'town':tr[8],'originalTown':tr[9],'NYmatchedTown':tr[10],'politicalEntity':tr[11],'group_size':tr[13],'stay_length':tr[14],'user_days':tr[15],'destination':tr[16]} 
                        noMatchDest.append(temp2)
            if matched > 1:
                if tempMatches[0]['trailRegister']==trailhead.upper()+' TRAIL REGISTER':
                    matchDest.append(tempMatches[0])
                elif tempMatches[1]['trailRegister']==trailhead.upper()+' TRAIL REGISTER':
                    matchDest.append(tempMatches[1])
                else:
                    noMatchList.add('trailhead:'+trailhead+', match count: '+str(matched))
                    noMatchDest.append(temp)
            #if there is only one match then the trip is good to go
            else:                
                matchDest.append(temp)
#write matched trips to the trip file
with open (trips, 'w', newline = '') as csvMatched:
    fieldnames = ['pkTripID','fkOriginGroupID','fkOriginID','fkDestinationID','trailRegister','trailName','matchedTrailname', 'mgmtUnit', 'date',
                  'state', 'town','originalTown','NYmatchedTown', 'politicalEntity', 'county', 'group_size','stay_length', 'user_days','destination' ]
    matchwriter = csv.DictWriter(csvMatched, fieldnames = fieldnames)
    matchwriter.writeheader()
    for m in matchDest:
        matchwriter.writerow(m)
    print ('matched files written to: '+trips)

#print out unmatched trip destinations and match count
print ('not matched: ')
for trip in sorted(noMatchList):  
    print (trip)
with open (unmatchedTripsDest, 'w', newline = '') as csvUnmatched:
    fieldnames = ['pkTripID','fkOriginGroupID','fkOriginID','trailName','matchedTrailname', 'mgmtUnit', 'date',
                  'state', 'town','originalTown','NYmatchedTown', 'politicalEntity', 'county', 'group_size','stay_length', 'user_days','destination' ]
    matchwriter = csv.DictWriter(csvUnmatched, fieldnames = fieldnames)
    matchwriter.writeheader()
    for n in noMatchDest:
        matchwriter.writerow(n)
    print ('unmatched trips written to: '+unmatchedTripsDest)

