#Written by Emma Tait for FEMC NY Rec Data project
#This script converts the iMap polygons and lines to to points and then merges them with the points dataset
#Last Updated 21 October 2019
#***********IMPORTANT NOTE********
#features must be split using the split tool in edit mode first to ensure that
#if a feature spans multiple towns there is a point in each town

import arcpy
import os

#location of imap files
folder = r'I:\WorkingProjects\NY_RecData\InvasivePlantData\iMapInvasives\iMap_northeast_state_plants_2019_10_02.gdb\iMap_northeast_state_plants_2019_10_02.gdb'
#path to scratch workspace
path = r'I:\WorkingProjects\NY_RecData\InvasivePlantData\scratch.gdb'

#use this to intially copy features to scratch database (can be done manually as well)
##arcpy.env.workspace = folder
##arcpy.env.overwriteOutput = True
##iMapFeatures = arcpy.ListFeatureClasses()
##for feature in iMapFeatures:
##    arcpy.CopyFeatures_management(feature, path +'\\iMap_'+feature)

arcpy.env.workspace = path
arcpy.env.overwriteOutput = True
line = path+'\\PRESENCE_LINE_select'
polygon = path+'\\PRESENCE_POLYGON_select'
points = path+'\\PRESENCE_POINT_select'

polyToPt = arcpy.FeatureToPoint_management(polygon,'iMap_polyToPt')
print ('polygons converted to point')
lineToPt = arcpy.FeatureToPoint_management(line,'iMap_lineToPt')
print ('lines converted to point')
iMap = arcpy.Merge_management([points,polyToPt,lineToPt],'iMap_9states')
print ('all features merged')
spatialRef = arcpy.SpatialReference('NAD 1983')
iMap = arcpy.Project_management(iMap,'iMap_9states_reproj',spatialRef)
arcpy.CopyFeatures_management(iMap, r'I:\WorkingProjects\NY_RecData\SpatialData\NY_RecData.gdb\iMap_9states')
print ('final iMap dataset made')
print ('script complete')
